package de.forck.midi;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import java.awt.Dimension;
import java.awt.FlowLayout;


public class AppStart{
	
	private static MyMidiOut midiOutput =  new MyMidiOut();
	private static MyMidiIn midiInput = new MyMidiIn();
	
	public static JFrame frame = new JFrame();
	
	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (UnsupportedLookAndFeelException e) {
			e.printStackTrace();
		} 
		showGUI();
		midiOutput.setPortOfMidiOut(0);
		setFocusToFrame();
	}
	
	private static void showGUI() {
		frame.setSize(new Dimension(400, 300));
		frame.setLocation(200, 200);
		frame.addKeyListener(new MyKeyListener());
		
		MidiOutPortChooser outDevices = new MidiOutPortChooser();
		MidiInPortChooser inDevices = new MidiInPortChooser();
		
		JPanel panel = new JPanel();
		panel.setLayout(new FlowLayout());
		panel.add(outDevices);
		panel.add(inDevices);
		
		frame.add(panel);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
	}
	
	public static MyMidiOut getMidiOutput(){
		return midiOutput;
	}

	public static MyMidiIn getMidiInput() {
		return midiInput;
	}
	
	public static void setFocusToFrame() {
		frame.requestFocusInWindow();
	}
}
