package de.forck.midi;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiSystem;
import javax.swing.JComboBox;


public class MidiInPortChooser extends JComboBox<String> implements ActionListener{

	private static final long serialVersionUID = -1L;
	
	MyMidiIn midiIn = new MyMidiIn();
	ArrayList<String> itemsOfMidiInChooser = new ArrayList<>();
	
	public MidiInPortChooser(){
		initializeList();
		addActionListener(this);
	}
	
	public void initializeList(){
		
		MidiDevice.Info[] infos = MidiSystem.getMidiDeviceInfo();
		itemsOfMidiInChooser.add("Computer");
		for (int i = 1; i < infos.length; i++) {
			try {
		    	if (!itemsOfMidiInChooser.contains(infos[i].getName())
					&& !infos[i].getName().equals("Microsoft GS Wavetable Synth")
					&& !infos[i].getName().equals("Microsoft MIDI Mapper")
					&& !infos[i].getName().equals("Real Time Sequencer")){
					itemsOfMidiInChooser.add(infos[i].getName());
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		for(String item : itemsOfMidiInChooser) {
			this.addItem(item);
		}
		
	}
	
	public void actionPerformed(ActionEvent e){
		String devName = (String)getSelectedItem();
		
        for (int i = 1; i < itemsOfMidiInChooser.size(); i++) {
			if (devName.equals(itemsOfMidiInChooser.get(i))){
				AppStart.getMidiInput().setPortOfMidiIn(i-1);
				Thread thread = new Thread(AppStart.getMidiInput());
				thread.start();
				break;
			}
		}
        AppStart.setFocusToFrame();
	}
}
