package de.forck.midi;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiSystem;
import javax.swing.JComboBox;


public class MidiOutPortChooser extends JComboBox<String> implements ActionListener{

	private static final long serialVersionUID = -1L;
	ArrayList<String> itemsOfMidiOutChooser = new ArrayList<>();

	public MidiOutPortChooser(){
		initializeList();
		addActionListener(this);
	}

	public void initializeList(){
		MidiDevice.Info[] infos = MidiSystem.getMidiDeviceInfo();

		for (int i = 0; i < infos.length; i++) {
			if (!itemsOfMidiOutChooser.contains(infos[i].getName())
					&& !infos[i].getName().equals("Gervill")
					&& !infos[i].getName().equals("Real Time Sequencer")	
					&& !infos[i].getName().equals("Microsoft MIDI Mapper")
					){
				itemsOfMidiOutChooser.add(infos[i].getName());
			}
		}
		for(String item : itemsOfMidiOutChooser) {
			this.addItem(item);
		}
	}

	public void actionPerformed(ActionEvent e){
		String devName = (String)getSelectedItem();
		for (int i = 0; i < itemsOfMidiOutChooser.size(); i++) {
			if (devName.equals(itemsOfMidiOutChooser.get(i))){			
				AppStart.getMidiOutput().setPortOfMidiOut(i);
				break;
			}
		}
		AppStart.setFocusToFrame();
	}
}
