package de.forck.midi;

import java.lang.invoke.MethodHandle;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.ShortMessage;

import java.lang.foreign.Linker;
import java.lang.foreign.FunctionDescriptor;
import java.lang.foreign.SymbolLookup;
import static java.lang.foreign.ValueLayout.*;


public class MyMidiIn implements Runnable{

	public boolean running = false;
	MyReceiver receiver = new MyReceiver();
	private int portNumber = 0;

	static {
		try {
			System.load("D:\\Dokumente\\Web\\forck.net\\java\\MidiTest\\MidifuctionsOfRtMidi.dll");
		}catch(UnsatisfiedLinkError e) {
			System.out.println("MidifuctionsOfRtMidi.dll konnte nicht gefunden werden.");
		}
	}
	static Linker linker = Linker.nativeLinker();
	
	public void stop() {
		running = false;
	}

	@Override
	public void run() {
		running = true;
		ShortMessage message = new ShortMessage();
		while(running) {
			try {
				Thread.sleep(5);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			int messageAsInt = this.receiveMidiForeignFuction(portNumber);

			try {
				message = new ShortMessage((messageAsInt >> 16)&0xF0, (messageAsInt >> 16)&0x0F, 
						(messageAsInt >> 8) & 0xFF, messageAsInt & 0xFF);

			} catch (InvalidMidiDataException e) {
				e.printStackTrace();
			}
			if(message.getCommand() != 0) {
				receiver.send(message, 0);
			}
		}       
	}

	private int receiveMidiForeignFuction(int port) {
		int value = 0;
		
		SymbolLookup loaderLookup = SymbolLookup.loaderLookup();
		MethodHandle receiveMidi = linker.downcallHandle(loaderLookup.find("receiveMidi").get(),
									FunctionDescriptor.of(JAVA_INT, JAVA_INT));
		try {
			value = (int)receiveMidi.invokeExact(port);
		} catch (Throwable e) {
			e.printStackTrace();
		} 
		return value;
	}
	
	public int setPortOfMidiIn(int portNumber) {
		int value = 0;
		SymbolLookup loaderLookup = SymbolLookup.loaderLookup();
		MethodHandle setPortOfMidiIn = linker.downcallHandle(loaderLookup.find("setPortOfMidiIn").get(),
				FunctionDescriptor.of(JAVA_INT, JAVA_INT)
				);

		try {
			value = (int)setPortOfMidiIn.invokeExact(portNumber);
		} catch (Throwable e) {
			e.printStackTrace();
		} 
		return value;
	}
}
