package de.forck.midi;

import java.lang.invoke.MethodHandle;
import java.lang.foreign.Linker;
import java.lang.foreign.FunctionDescriptor;
import java.lang.foreign.SymbolLookup;
import static java.lang.foreign.ValueLayout.*;


public class MyMidiOut {

	static {
		try {
			System.load("D:\\Dokumente\\Web\\forck.net\\java\\MidiTest\\MidifuctionsOfRtMidi.dll");
		}catch(UnsatisfiedLinkError e) {
			System.out.println("MidifuctionsOfRtMidi.dll konnte nicht gefunden werden.");
		}
	}
	
	static Linker linker = Linker.nativeLinker();

	public synchronized void sendMidiMessage(int statusAndChannel, int data1, int data2) {

		SymbolLookup loaderLookup = SymbolLookup.loaderLookup();
		MethodHandle sendMidiMessage = linker.downcallHandle(loaderLookup.find("sendMidiMessage").get(),
				FunctionDescriptor.ofVoid(JAVA_INT, JAVA_INT, JAVA_INT));
		try {
			sendMidiMessage.invokeExact(statusAndChannel, data1, data2);
		} catch (Throwable e) {
			e.printStackTrace();
		} 
	}

	public int setPortOfMidiOut(int portNumber) {

		int value = 0;
		SymbolLookup loaderLookup = SymbolLookup.loaderLookup();
		MethodHandle setPortOfMidiOut = linker.downcallHandle(loaderLookup.find("setPortOfMidiOut").get(),	
											FunctionDescriptor.of(JAVA_INT, JAVA_INT));
		try {
			value = (int)setPortOfMidiOut.invokeExact(portNumber);
		} catch (Throwable e) {
			e.printStackTrace();
		} 
		return value;
	}	

}
